<![CDATA[

/*
Simple debugger object used to make it easier to examine the state of the stylesheet

Typical usage:

	goDBG.Init(); // initialize the debug object

	// add some data to it
	goDBG.AddProperty("curlang", sCurLang);
	goDBG.AddProperty("rids", sRIDs);
	goDBG.AddProperty("activerid", sActiveRID);

	// within an XSL template, use the following to output the data
	<xsl:eval>goDBG.DumpProperties();</xsl:eval>

*/

function CDebugger()
{
	this.AddProperty = CDebugger_AddProperty;
	this.Init = CDebugger_Init;
	this.GetProperty = CDebugger_GetProperty;
	this.DumpProperties = CDebugger_DumpProperties;

	this.Init();
}

function CDebugger_AddProperty(sName, vValue)
{
	this._data[sName] = vValue;
}

function CDebugger_Init()
{
	this._data = new Object();
}

function CDebugger_GetProperty(sName)
{
	return this._data[sName];
}

function CDebugger_DumpProperties()
{
	var sProps = "DBG: ";
	for (sProp in this._data)
	{
		sProps += sProp + "=" + this._data[sProp] + ",";
	}
	return sProps;	
}

]]>
