// return an instance of the Visual Studio metadata helper object
function EnsureVSMetadata(oTopic, oCtx)
{
	if (!EnsureVSMetadata._oVSHelper)
	{
		EnsureVSMetadata._oVSHelper = new VSMetadata(oDoc, oCtx);
	}

	return EnsureVSMetadata._oVSHelper;
}

function VSMetadata(oCtx)
{
	this._oCtx = oCtx;
	this._oRegRef = new RegExp("(ref|const|struct|iface|isv_element|enum|function|object|method|pi|property|attribute|pseudo_class|pseudo_element|declaration|rule|event|collection|behavior|srcdisp|class|dhfilter|dhfilter_property|winmsg|dhcmdid)");
}

VSMetadata.prototype.GetTopicType = function()
{
	var oDoc = this._oCtx.GetDocument();
	if (!oDoc)
	{
		return "";
	}
	
	var oMD = oDoc.selectSingleNode("/inetsdk:topic/metadata");
	if (!oMD)
	{
		return "";
	}

	var sType = oMD.getAttribute("type");
	if (this._oRegRef.test(sType))
	{
		return "kbSyntax";
	}
	else if (sType == "howto")
	{
		return "kbHowTo";
	}
	else if (sType == "ovw")
	{
		return "kbOrient";
	}
	else
	{
		// BUGBUG: What's the catchall VS topictype?
		return sType;
	}
}

