/*
	void fxWNInit(void)
	Called from PostInit
	Sets the selected technology index to 0, and invokes fxPopulateWNTable.
*/
function fxWNInit(){
	if(oBD.majorVer>=5){
		if(typeof(_wntable1)=="object"){
			// If IE is version 5.5 or greater and the user is running Win2000
			if(oBD.fullVer>=5.5){
				var aH1=window.document.body.getElementsByTagName("H1");
				if(aH1.length){
					aH1[0].outerHTML='<IFRAME ID="_wnlogoframe" SRC="55newdynamic.htm" SCROLLING="NO" NORESIZE="1" FRAMEBORDER="NO" STYLE="width:100%; height:150px"></IFRAME>';
				}
			}
			fxAddSelTech();
			// If an error occurs and oSelTech is not added, then do not proceed.
			if(typeof(oSelTech)=="object"){ 
				oSelTech.selectedIndex=0;
				fxPopulateWNTable(_wntable1);
			}
	
		}
	}
}

/*
	void fxAddSelTech(void)
	Called from fxWNInit
	Adds the SELECT element to the table.
*/
function fxAddSelTech(){
	var sHtml='<SELECT onchange="updateWNTable(_wntable1)" STYLE="font-size: 8pt; font-family: Arial;" ID="oSelTech"><OPTION>All Features</OPTION></SELECT>';
	var aCells=_wntable1.rows(0).cells;
	aCells(0).innerHTML=sHtml;
	aCells(1).innerHTML="Descriptions for " + oSelTech.options[0].text;
}

/*
	void fxPopulateWNTable(TABLE oTable)
	Called from fxWNInit
	Creates technology list for SELECT, and adds hash values to Whats New table rows.
	
*/
function fxPopulateWNTable(oTable){
	var aRows=oTable.rows;
	var iRLen=aRows.length;
	var aTechs=new Array();
	for(var i=0;i<iRLen;i++){
		var oRow=aRows[i];
		var oCell1=oRow.cells(0);
		var vTechs=oCell1.getAttribute("techs");
		if(vTechs){
			var aVTechs=vTechs.split(";");
			aTechs=aTechs.concat(aVTechs);
		}
	}
	for(var a=0;a<aTechs.length;a++){
		var sTech=aTechs[a];
		if(sTech!=""){
			var bAddOption=true;
			for(var h=0;h<oSelTech.options.length;h++){
				if(sTech==oSelTech.options[h].value){
					bAddOption=false;
				}
			}
			if(bAddOption==true){
				var sTechName=sTech;
				if(g_techitems[sTech]){
					sTechName=g_techitems[sTech].name;
				}
				oSelTech.options[oSelTech.options.length]=new Option(sTechName,sTech);
			}	
		
		}
	}
	
}

/*
	void updateWNTable(TABLE oTable)
	called from SELECT oSelTech onchange event
	Shows/Hides table rows based on matching values in the techs attribute
*/
function updateWNTable(oTable){
	
	var iRowLen=0;
	var iIndex1=oSelTech.selectedIndex;
	var oOption=oSelTech.options[iIndex1];
	var sFilter1=oOption.value;
	var sSelText=oOption.text;
	var aRows=oTable.rows;
	var iRLen=aRows.length;
	// Skip first row since this includes the labels
	for(var i=1;i<iRLen;i++){
		var oRow=aRows[i];
		var bShowItem=true;
		var oCell1=oRow.cells(0);
		var sCellText=oCell1.innerText;
		var vTechs=oCell1.getAttribute("techs");
		if(vTechs){
			if((iIndex1>0)&&(!vTechs.match(sFilter1 + ";"))){
				bShowItem=false;
			}
		}
		if(bShowItem==true){
			oRow.style.display="block";
		}
		else{
			oRow.style.display="none";
		}
	}
	var sDescText="Descriptions for " + sSelText;
	var sTipText="";
	var oDescRow=aRows[0];
	if(g_techitems[sFilter1]){
		sTipText=g_techitems[sFilter1].desc;
	}
	oDescRow.title=sTipText;
	oDescRow.cells[1].innerHTML=sDescText;
}
